package com.foo.myservice.jmx;

import org.apache.cxf.Bus;
import org.apache.cxf.management.InstrumentationManager;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import javax.management.JMException;
import javax.management.ObjectName;

public class MyServiceMBeanRegistration {
    private final Logger logger = LoggerFactory.getLogger(getClass());

    private MyServiceMBeanImpl mbean;
    private Bus bus;

    public void doRegistration() {
        logger.info("Running doRegistration...");
        InstrumentationManager imanager = bus.getExtension(InstrumentationManager.class);

        try {
            final ObjectName objectName = new ObjectName("org.apache.cxf:type=foo,name=bar");
            imanager.register(mbean, objectName);
        } catch (JMException e) {
            logger.error("Couldn't register MyServiceMBean", e);
        }
        logger.info("Done!");
    }

    public void setMbean(MyServiceMBeanImpl mbean) {
        this.mbean = mbean;
    }

    public void setBus(Bus bus) {
        this.bus = bus;
        logger.info("the bus is " + bus.getId());
    }
}
