package com.foo.myservice.service.routes;

import org.apache.camel.LoggingLevel;
import org.apache.camel.builder.RouteBuilder;

public class MyServiceRoute extends RouteBuilder {

    private static final String ROUTE_NAME = "MyService";
    private static final String SUBMIT = "submit";
    private static final String RECEIPT = "receipt";
    private static final String SUBMIT_FORMTASK_SERVICE = "submitFormtaskService";
    private static final String RUN_SUBMIT_TASK = "runSubmitTask";
    private static final String CHECK_RECEIPT_SERVICE = "checkReceiptService";
    private static final String CHECK_RECEIPT = "checkReceipt";

    @Override
    public void configure() {

        onException(Exception.class)
                .to("log:" + this.getClass().getName());

        from("{{route.myservice.endpoint.submit}}")
                .routeId(getFinalRouteName(SUBMIT))
                .log(LoggingLevel.INFO, "Running: " + RUN_SUBMIT_TASK)
                .beanRef(SUBMIT_FORMTASK_SERVICE, RUN_SUBMIT_TASK)
                .log(LoggingLevel.INFO, "Done: " + RUN_SUBMIT_TASK)
        ;

        from("{{route.myservice.endpoint.receipt}}")
                .routeId(getFinalRouteName(RECEIPT))
                .log(LoggingLevel.INFO, "Running: " + CHECK_RECEIPT)
                .beanRef(CHECK_RECEIPT_SERVICE, CHECK_RECEIPT)
                .log(LoggingLevel.INFO, "Done: " + CHECK_RECEIPT)
        ;
    }

    private String getFinalRouteName() {
        return getFinalRouteName("");
    }

    private String getFinalRouteName(String routeName) {
        return ROUTE_NAME + (routeName != null && routeName.length() > 1 ? routeName.substring(0, 1).toUpperCase() + routeName.substring(1) : "") + "Route";
    }
}
